package com.logicbig.example;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.ext.ReaderInterceptor;
import javax.ws.rs.ext.ReaderInterceptorContext;
import javax.ws.rs.ext.WriterInterceptor;
import javax.ws.rs.ext.WriterInterceptorContext;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Scanner;

public class MyClientInterceptor implements WriterInterceptor, ReaderInterceptor {

    @Override
    public void aroundWriteTo(WriterInterceptorContext context)
            throws IOException, WebApplicationException {
        System.out.println("-- in MyInterceptor#aroundWriteTo() --");
        OutputStream os = context.getOutputStream();
        String msg = " My output message added in client interceptor.";
        os.write(msg.getBytes());
        context.proceed();
    }

    @Override
    public Object aroundReadFrom(ReaderInterceptorContext context)
            throws IOException, WebApplicationException {
        System.out.println("-- in MyInterceptor#aroundReadFrom() --");

        InputStream is = context.getInputStream();
        String body = new Scanner(is, "UTF-8").useDelimiter("\\A").next();

        context.setInputStream(new ByteArrayInputStream(
                (body+" My appended message from interceptor.\n").getBytes()));
        Object result = context.proceed();
        return result;
    }

}